#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 YellowGreen
#property indicator_color2 Red
#define SignalName "WilliamsBands"

//
//
//
//
//

extern int   MAMode        = 0;
extern int   BreakPips     = 3;
extern bool  showArrows    = true;
extern bool  alertsOn      = true;
extern bool  alertsMessage = true;
extern bool  alertsSound   = false;
extern bool  alertsEmail   = false;

//
//
//
//
//

double ExtMapBuffer1[];
double ExtMapBuffer2[];

//
//
//
//
//

int      maxArrows;
int      ArrowGap;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
      return(0);
}
int deinit()
{
   DeleteArrows();
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   double   ima,stdDev,atr;
   int      counted_bars=IndicatorCounted();
   int      limit;
   int      i;
   
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   //
   //
   //
   //
   //
   
   for (i=0;i<limit;i++) {
         ima    = iMA(NULL,0,3,0,MAMode,PRICE_CLOSE,i);
         stdDev = iStdDev(NULL,0,3,0,MAMode,PRICE_CLOSE,i);
         atr    = iATR(NULL,0,3,i);
               ExtMapBuffer1[i] = ima + (stdDev+atr)/2;
               ExtMapBuffer2[i] = ima - (stdDev+atr)/2;
      }

   //
   //
   //
   //
   //
   
   DeleteArrows();
   if (showArrows)
      {
         ArrowGap = MathCeil(iATR(NULL,0,50,0)/Point);
         limit     = MathMin(Bars,300);
            for (i=limit; i>=0 ;i--)
               {
                  if (High[i] > (ExtMapBuffer1[i]+(BreakPips*Point))) DrawArrow(i,"upBreak");
                  if (Low[i]  < (ExtMapBuffer2[i]-(BreakPips*Point))) DrawArrow(i,"downBreak");
               }
      }
   if (alertsOn)
      {
         if (High[0] > (ExtMapBuffer1[0]+(BreakPips*Point))) doAlert(" breakout up");
         if (Low[0]  < (ExtMapBuffer2[0]-(BreakPips*Point))) doAlert(" breakout down");
      }
   
   //
   //
   //
   //      
   //----
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void DrawArrow(int i,string type)
{
   string name;
      
   maxArrows++;
   name = StringConcatenate(SignalName,maxArrows);
         ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         if (type=="upBreak")
            {
               ObjectSet(name,OBJPROP_PRICE1,High[i]+(ArrowGap*Point));
               ObjectSet(name,OBJPROP_ARROWCODE,242);
               ObjectSet(name,OBJPROP_COLOR,Red);
            }
         else
            {
               ObjectSet(name,OBJPROP_PRICE1,Low[i]-(ArrowGap*Point));
               ObjectSet(name,OBJPROP_ARROWCODE,241);
               ObjectSet(name,OBJPROP_COLOR,LimeGreen);
            }
}
void DeleteArrows()
{
   while(maxArrows>0) { ObjectDelete(StringConcatenate(SignalName,maxArrows)); maxArrows--; }
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];
      
          //
          //
          //
          //
          //
            
          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Williams bands ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsSound)   PlaySound("alert2.wav");
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Williams bands breakout"),message);
      }        
}  